//###################################################################################
// File: dostest.c
//
// Liest eine Datei auf dem CF bis zum Ende.
//
//#########################################################################
// Last change: 29.07.2005
//#########################################################################
// hk@holger-klabunde.de
// http://www.holger-klabunde.de/index.html
//#########################################################################
// Compiler: AVR-GCC 3.4.5
//#########################################################################
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

#include "mydefs.h"
#include "protos.h"
#include "../lcd.h"
#include "../dos.h"
#include "../serial.h"

//"volatile" fr alle Variablen die in Interrupt's gendert werden
unsigned int volatile countclock;

//###################################################################################
// interrupt every 47.4ms  @ 11.0592MHz
// interrupt every 32.77ms @ 16.0000MHz
SIGNAL(SIG_OVERFLOW1)        // signal handler for timer1 overflow interrupt
//###################################################################################
{
 countclock++;
}

//###################################################################################
/* Hauptprogramm */
int main(void)
//###################################################################################
{
  
 DDRC=0xFF;  	// set io-pins on PortC
 PORTC=0; 	//LCD-Datenbus

 DDRD=0xF2;  	// set io-pins on PortD
 PORTD=0x02; 	//LCD-Steuersignale siehe lcd.h

 DDRA=0; 	//Alles Eingnge
 PORTA=0xFF; 	//Eingnge mit Pullups setzen

 SFIOR&=!(1<<PUD); 	//Pullups Enable
// SFIOR=0; 	//Pullups Enable

 LCDInit();
 ser_init();

#ifdef MMC_CARD_SPI //SD_CARD_SPI too !
 MMC_IO_Init();
#endif
 
//Timer1
 TCCR1A=0; 
 TCCR1B=0x02;        //Timer1 Start Takt = F/8 => 47.4ms at 11.059MHz
 TIMSK=(1<<TOIE1);   // enable timer1 int

 sei();              //enable interrupts

 LCDCls();
 LCDWrite("FAT DOS-ReadFileRaw-Test1");
 LCDPos(2,1);
 LCDWrite("by Holgi");
 Delay1ms(1000);
 LCDCls();

 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   LCDCls();
   LCDWrite("Flash meldet sich nicht !");
   while(1);
  }
 
 RED_ON();
 GREEN_OFF();

 countclock=0;
 ReadFileRaw("ABCD");
  
 GREEN_ON();
 RED_OFF();
 cli(); // Disable interrupts

 LCDPos(2,1);
 ShowHex((unsigned char)(countclock>>8));
 ShowHex((unsigned char)(countclock));
 
 for(;;) // loop forever
  {
  }
}

