//###########################################################
// File: readraw.c
//
// Benutzung auf eigene Gefahr !
//
// Use at your own risk !
//
//#########################################################################
// Last change: 29.07.2005
//#########################################################################
// hk@holger-klabunde.de
// http://www.holger-klabunde.de/index.html
//#########################################################################
// Compiler: avr-gcc 3.4.3
//#########################################################################
#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "dos.h"
#include "serial.h"
#include "lcd.h"

//###########################################################
// reads all sectors of the file.
// you have to check FileSize from direntry to see how
// many bytes of last sector are valid for the file. 
unsigned char ReadFileRaw(char *name)
//###########################################################
{
 unsigned long FilePosition;
 unsigned long tmpsector;
 unsigned char by;
 unsigned int i;

 if(FindName(name)==FULL_MATCH)
  {
   FilePosition=0; //actual read position
  
   tmpsector=GetFirstSectorOfCluster(FileFirstCluster);

   do
    {
#ifdef MMC_CARD_SPI
     MMC_CS_OFF();
     MMCStartReadSector(tmpsector);
//     MMCStartReadMultipleSector(tmpsector);
#endif

#ifdef COMPACTFLASH_CARD
     CFStartReadSector(tmpsector);
     CF_CS_OFF();
#endif

     for(i=0; i<BYTE_PER_SEC; i++) //sector loop
      {
#ifdef MMC_CARD_SPI
       SPI_WRITE(0xFF);
       SPI_WAIT();
       by=SPDR;
#endif

#ifdef COMPACTFLASH_CARD
       CF_RD_OFF();
       NOP; //Schon bei 8MHz mu man hier etwas warten
       NOP; //Es knnte evtl. ntig sein hier noch mehr
        //nop einzufgen, um mglichst viele CF zu lesen
        //Bei mir reichten bisher 2 nop
        //Sicherheitshalber noch einen mehr
       NOP;

#ifdef F_16 //16MHz processor clock
       NOP;
#endif
   
       by=CF_READ_DATA();
       CF_RD_ON();
#endif

       FilePosition++; // count bytes read
       if(FilePosition<=FileSize) // end of file reached ?
        {
         //################################################
         // 'by' holds your data now. use it as you want 
         // put your function to use 'by' below
         // example: ser_putc(by);
         ser_putc(by);
         //
         //****************************
         // load your MP3-Chip here ;)
         //****************************
         //
         // end of your function
         // don't do a RETURN in your function
         // the two loops you are in now MUST end itself
         // all bytes of a sector have to be read, even if
         // they are not used by your file
         //################################################
         
        }//if(FilePosition<=FileSize) 
      }//for(i=0;...)

#ifdef MMC_CARD_SPI
     SPI_WRITE(0xFF); //CRC after sector
     SPI_WAIT();
     SPI_WRITE(0xFF);
     SPI_WAIT();
#endif

     tmpsector++; //next sector
    }while(FilePosition < FileSize);

  }//if(FindName(name)==FULL_MATCH)
 else return F_ERROR;  // something went wrong

#ifdef MMC_CARD_SPI
 MMC_CS_ON();
#endif

#ifdef COMPACTFLASH_CARD
 CF_CS_ON();
#endif

 return F_OK;
}
